// Exp-1 To generate basic discrete signal used in Digital Signal Processing

// Version : Scilab 5.4.1
// Operating Syatem : Window-xp, Window-7

clc;
clear;
xdel(winsid());
t=0:0.1:20;
f=0.2;
pi=3.14;


////////////////////////   SINEWAVE   /////////////////
x1=sin(2*pi*f*t);
//scf();
subplot(231);
plot(t,x1,'cya+','marker','d','markerfac','green','markeredg','red');
title('Sinewave','color','red','fontsize', 4);
//xtitle( 'Sinewave', 'Index', 'Amplitude') ;
xlabel("Index", "fontsize", 2,"color", "blue");
ylabel("Amplitude", "fontsize", 2, "color", "blue");


////////////////////////   Cosine Wave   /////////////////
x2=cos(2*pi*f*t);
//scf();
subplot(232);
plot(t,x2,'cya+','marker','d','markerfac','red','markeredg','yel');
title('Cosinewave','color','red','fontsize', 4);
xlabel("Index", "fontsize", 2,"color", "blue");
ylabel("Amplitude", "fontsize", 2, "color", "blue");


////////////////////////   Impulse Wave   /////////////////
t1=-10:10;
x3=[zeros(1,10) 1 zeros(1,10)];
//scf();
subplot(233);
plot(t1,x3,'cya+','marker','d','markerfac','green','markeredg','red');
title('Impulse','color','red','fontsize', 4);
xlabel("Index", "fontsize", 2,"color", "blue");
ylabel("Amplitude", "fontsize", 2, "color", "blue");


////////////////////////   Ramp Wave   /////////////////
t4=0:10;
x4=t4;
//scf();
subplot(234);
plot(t4,x4,'cya+','marker','d','markerfac','green','markeredg','red');
title('Ramp Wave','color','red','fontsize', 4);
xlabel("Index", "fontsize", 2,"color", "blue");
ylabel("Amplitude", "fontsize", 2, "color", "blue");


////////////////////////   Exponetial Wave   /////////////////
t5=0:10;
x5=exp(t5);
//scf();
subplot(235);
plot(t5,x5,'cya+','marker','d','markerfac','green','markeredg','red');
title('Exponetial Wave','color','red','fontsize', 4);
xlabel("Index", "fontsize", 2,"color", "blue");
ylabel("Amplitude", "fontsize", 2, "color", "blue");


////////////////////////   Random Wave   /////////////////

x6=rand(1,100);
//scf();
subplot(236);
plot(1:length(x6),x6,'cya+','marker','d','markerfac','green','markeredg','red');
title('Random Wave','color','red','fontsize', 4);
xlabel("Index", "fontsize", 2,"color", "blue");
ylabel("Amplitude", "fontsize", 2, "color", "blue");



/////////////Impulse Sequence  /////////////////
n1=1,n0=50,n2=100;
if((n0<n1)|(n0>n2)|(n1>n2))
    error('arugument incorrect');
end
n=[n1:n2];
x7=[(n-n0)==0,1];
scf()
subplot(121);
plot(n,x7(n1:n2),'cya+','marker','d','markerfac','green','markeredg','red');
title('Impulse Sequence','color','red','fontsize', 4);
xlabel("Index", "fontsize", 2,"color", "blue");
ylabel("Amplitude", "fontsize", 2, "color", "blue");


////////////////// Step Sequence  ////////////////
n1=1,n0=50,n2=100;
if((n0<n1)|(n0>n2)|(n1>n2))
    error('arugument incorrect');
end
n=[n1:n2];
x8=[(n-n0)>=0,1];
subplot(122);
plot(n,x8(n1:n2),'cya+','marker','d','markerfac','green','markeredg','red');
title('Step Sequence','color','red','fontsize', 4);
xlabel("Index", "fontsize", 2,"color", "blue");
ylabel("Amplitude", "fontsize", 2, "color", "blue");






